<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once "$path/common.php";
include_once "$path/Model_adm.php";

if($user->getDroits($dbconnection,"esia_administration") !=1 || $user->getDroits($dbconnection,"esia_device") != 1 )
{
        $smarty->display('no_access.html');
        exit(0);
}

include_once DEVICE_CLASS;
include_once MVCMODEL;
include_once $path.'/plugin/gesa/model_gesa.php';
include_once '/usr/local/esia/keystore/scripts/keystore.lib.php';
include_once $path.'/libs/logo_oid.hash.php';

$webp_name='WEBP_HYPERVISOR';
$arr = Model_esia::getWebPlugin($dbconnection,false,$webp_name);
$apache_plugin_path = $arr[0]['apache_path'];
$template_path= $path.$apache_plugin_path.'templates/';

$webp_name_path='virtualization';
$webp_model='model_'.$webp_name_path.'.php';
include_once $path.$apache_plugin_path.$webp_model;

$smarty->assign('adm_device', 'adm_device');
//vérification des droits d'accès
$SUCCESS=null;
$action='listNode';
$category='node';

if(!empty($_SESSION['ADM_MESSAGE']))
{
	if($_SESSION['ADM_MESSAGE']['TYPE']=='SUCCESS')
	{
		$SUCCESS[]=$_SESSION['ADM_MESSAGE']['MESSAGE'];
	}
	else
	{
		$ERROR[]=array('name'=>'Advance node error','message'=>$_SESSION['ADM_MESSAGE']['MESSAGE']);
	}
	unset($_SESSION['ADM_MESSAGE']);
}
try
{
    //on récupère l'action demandée si il n'y a pas de demande on liste.
    if(isset($_GET['action']))
    {
	    $action = $_GET['action'];
    }
    //type de vue demandé
    //on récupère l'action demandée si il n'y a pas de demande on liste.
    if(isset($_GET['category']))
    {
	    $category = $_GET['category'];
    }
    $smarty->assign('category', $category);
    //chargement des informations sur le noeuds
    if( $category =='node')
    {
        if( $action == 'treat_create')
        {
            try
            {
                $cluster_id = $_REQUEST['cluster_id'];
                $device_name = $_REQUEST['name'];
                $hypervisor_name = $_REQUEST['hypervisor_name'];
                $node_group =  $_REQUEST['nodegroup'];
                $address = $_REQUEST['ip'];
                $description = $_REQUEST['description'];

                $device_type = Model_virtualization::getHypervisorDeviceType();
                $cluster_node = Model_esia::InstanceNode($dbconnection,$_REQUEST['cluster_id']);

                if(	$user->getDroits($dbconnection,"device_view",$cluster_node->getName()) !=1)
                {
                    $smarty->display('no_access.html');
                    exit(0);
                }

                //Ajout du device
                $new_node = $cluster_node;
                $new_node->setID(NULL);
                $new_node->setType($device_type);
                $new_node->setName($device_name);
                $new_node->setGroupList($node_group);
                $new_node->setDescription($description);
                $new_node->setIPAddress($address);
                $new_node->setId(Model_adm::addNode($dbconnection,$new_node));
                Model_adm::addDeviceInDefaultGroup($dbconnection,$new_node);

                $node_id = $new_node->getID();

                //Ajout dans advance_node
                Model_virtualization::linkNodeToCluster($dbconnection,$node_id,$cluster_id);
                Model_virtualization::setHypervisorName($dbconnection,$node_id,$hypervisor_name);

                //Paramètres d'authentication
                $fromDatabaseParams = Model_virtualization::getAuthenticationParams($dbconnection,$cluster_id);
                $url = $fromDatabaseParams['url'];
                $parse = parse_url($url);
                $parse['host'] = $address;

                $fromDatabaseParams['url'] = $parse['scheme'] . '://' . $parse['host'] . ':' . $parse['port'];

                Model_virtualization::updateAuthenticationParams($dbconnection,$node_id,$fromDatabaseParams['url'],$fromDatabaseParams['login'],$fromDatabaseParams['password'],$fromDatabaseParams['driver']);

                //On ajoute un pattern de services
                $pattern_name = 'default_api_hypervisor';
                $pattern = Model_adm::getPatternService($dbconnection,$pattern_name);
                $pattern = array_shift($pattern);
                Model_adm::assignPatternServiceNode($dbconnection,$pattern['id'],$node_id);

                $ret['name'] = '';
                $ret['message'] = $lang['VIRT_ADV_CONFIG_CHANGED'];
                $SUCCESS[]=$ret;

                Model_virtualization::testDriver($dbconnection,$fromDatabaseParams,$fromDatabaseParams['driver']);
                $ret['name'] = '';
                $ret['message'] = $lang['VIRT_ADV_REACHEABLE_DEVICE'];
                $SUCCESS[] = $ret;
            }
            catch(Exception $e)
            {
                $ERROR[]=array('name'=>'Unknown Error','message'=>$e->getMessage());
            }
        }
        elseif($action=="create"||$action=="modif"||$err_treat!=0)
        {
            $cluster_id = $_REQUEST['cluster_id'];
            $cluster_node = Model_esia::InstanceNode($dbconnection,$cluster_id);

            if(	$user->getDroits($dbconnection,"device_view",$cluster_node->getName()) !=1)
            {
                $smarty->display('no_access.html');
                exit(0);
            }

            $hypervisor_name = $device_name  = $_REQUEST['name'];
            $address = $_REQUEST['address'];
            $node_group = $cluster_node->getGroupList();
            $description = $cluster_node->getDescription();
        }
    }
}
catch(Exception $e)
{
    $ERROR[]=array('name'=>'Unknown Error','message'=>$e->getMessage());
}




$smarty->assign('adm_node_name',$hypervisor_name);
$smarty->assign('adm_ip',$address);
$smarty->assign('adm_dev_list_group',$node_group);
$smarty->assign('adm_node_action', $action);
$smarty->assign('adm_description',$description);
$smarty->assign('cluster_id',$cluster_id);
$smarty->assign('hypervisor_name',$hypervisor_name);
$arr = Model_esia::getGroupDeviceIn($dbconnection);
$select =array();
foreach($arr as $top)
{
    $tmp = convert_tree_to_select($top,0);
    $select = array_merge($select, $tmp);
}
$smarty->assign('adm_nodegroup', $select);

$smarty->assign('ERRORS',$ERROR);
$smarty->assign('ADM_MESSAGE',$SUCCESS);

$smarty->display($template_path.'adv_dialog_node.html');

function convert_tree_to_select($top,$itt,$parentid=null,$parentname=null)
{
	/*for($i=0;$i<$itt;$i++)
		echo'=';
	echo $top['name'].'<br />';*/
	$pname=null;
	if(isset($parentname))
	{
		$pname = $parentname.' > '.$top['name'];
	}
	else
	{
		$pname = $top['name'];
	}
	$arr=array();
	$arr[]=array('id'=>$top['id'],'name'=>$top['name'],'level'=>$itt,'parent'=>$parentid,'parent_name'=>$pname);
	$itt++;
	if(isset($top['child']))
	{
		$tmp=array();
		foreach($top['child'] as $child)
		{
			$tmp = convert_tree_to_select($child,$itt,$top['id'],$pname);
			$arr = array_merge($arr, $tmp);
		}
	}

	return $arr;
}
?>
