<?php
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';
include_once 'inc/control/common.php';

$webp_name='WEBP_HYPERVISOR';
$webp_name_path='virtualization';

$webp_model='model_'.$webp_name_path.'.php';
include_once($path.$apache_plugin_path.$webp_model);
include_once($path.$apache_plugin_path."inc/common_lib.php");

if( !is_object($node))
{
	$node = Model_adm::InstanceNode($dbconnection,$node_id);
}

if(	$user->getDroits($dbconnection,"virtualization_access",$node->getName()) !=1
	|| $user->getDroits($dbconnection,"device_view",$node->getName()) !=1)
{
	$smarty->assign('no_header',TRUE);
	$smarty->display('no_access.html');
	exit(0);
}

$device_type = $node->getType();
if( $device_type == Model_virtualization::getClusterDeviceType() )
{
	$virt_type = 'cluster';
}
else
{
	$virt_type = 'hypervisor';
}

$action = NULL;
if( isset($_REQUEST['action']))
{
	$action = $_REQUEST['action'];
}

if( $action == 'volumes' )
{
	$cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);
	$mode = NULL;

	$volumes = array();
	if( isset($_REQUEST['vm']))
	{
		$mode = 'vm';
		$vm = $cluster->getVM($_REQUEST['vm']);
		$volumes = $vm->getVolumes();
	}
	elseif (isset($_REQUEST['storage']) )
	{
		$mode = 'storage';
		$storages_list = $cluster->getStorages();
		$storage = NULL;
		foreach($storages_list as $row)
		{
			if( $row->getID() == $_REQUEST['storage'])
			{
				$storage = $row;
				break;
			}
		}
		if( $storage != NULL )
		{
			$volumes = $storage->getVolumes();
		}
	}

	$volumes_output = array();
	foreach($volumes as $row)
	{
		$retRow['id'] 	= $row['id'];
		$retRow['name'] = $row['name'];
		$retRow['desc'] = $row['desc'];

		$size_used = bytesToHuman( $row['size_used'], $row['size_used']);
		$size_virt = bytesToHuman( $row['size_virt'], $row['size_virt']);

		$retRow['size_used'] = $size_used['human']['usage'] . ' ' . $size_used['human']['unit'];
		$retRow['size_virt'] = $size_virt['human']['usage'] . ' ' . $size_virt['human']['unit'];
		//$retRow['io_read'] = $row['io_read'];
		//$retRow['io_write'] = $row['io_write'];
		$retRow['io_read'] = number_format($row['io_read'], 0, ',', ' ');
		$retRow['io_write'] = number_format($row['io_write'], 0, ',', ' ');

		$retRow['storage'] = $row['storage']->getName();
		$retRow['vm'] = array();
		foreach($row['vm'] as $vm)
		{
			if( is_object($vm))
			{
				$retRow['vm'][] = $vm->getName();
			}
		}
		$retRow['vm'] = implode(',',$retRow['vm']);
		$volumes_output[] = $retRow;
	}
/*
	echo "<pre>";
	print_r($volumes_output);
	echo "</pre>";
	exit(0);
*/
	$smarty->assign('action',$action);
	$smarty->assign('mode',$mode);
	$smarty->assign('output_array',$volumes_output);
}
elseif ($_GET['action'] == 'snapshots') {
	$cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);

    $vmid = $_REQUEST['vmid'];
    $hostname = $_REQUEST['host'];

    $vm = $cluster->getVM($vmid);
    $statSnap = $vm->getSnapshots();

    if ($_REQUEST['Todo'] == 'createSnap') {
        $snap_description = null;
        $snap_name = null;
        $snap_name = $_POST['name'];
        $snap_description = $_POST['DescriptionSnap'];

        if ($snap_description != null && $snap_name != null) {
        //    $newSnap = $dr->create_snapshot($dr, $vmid, $snap_name, $hostname, $snap_description);
        } elseif ($snap_name != null) {
        //    $newSnap = $dr->create_snapshot($dr, $vmid, $snap_name, $hostname);
        }
    }

    $snap_output = array();
    foreach($statSnap as $row)
    {
        $retRow = array();
        $retRow['name'] = $row['name'];
        $date = date('d/m/Y', $row['time']) . ' &agrave; ' . date('H:i:s', $row['time']);
        $retRow['snaptime'] = '<span hidden>' . $row['time'] . '</span>' . $date;
        $retRow['description'] = $row['description'];
        //$retRow['vmstate'] = 1;
        $snap_output[] = $retRow;
    }

    $smarty->assign('url', $_SERVER['PHP_SELF']);
    $smarty->assign('vmid', $vmid);
    $smarty->assign('vmSnap', $snap_output);
    $smarty->assign('host', $hostname);
}

$smarty->display($template_path.'dialog_virtualization.html');
