<?php
/**
    @file
    @brief Copie de la classe principal de la  gestion des noeuds
    @details
    Ce fichier contient une copie simplifiée de la classe principale de gestion des noeuds
    Il est inclut dans le fichier common.class.php uniquement ci la classe principale d'Esia Device
    n'est pas déjà inclut. Le but de la présence de ce fichier permet d'utiliser les drivers
    en dehors de l'interface web d'Esia.
    @author Julien George
*/
class Device
{
        protected $id;
        protected $name;
        protected $type;
        protected $description;
        protected $ip;
        protected $ip_version;
        protected $manufacturer;
        protected $manufacturer_logo;
        protected $os;
        protected $os_version;

        public function __construct ($dev=NULL)
        {
            if(is_object($dev))
            {
                    if(get_class($dev)=='Device')
                    {
                            $this->constructDevice($dev);
                    }
                    else
                    {
                            throw DeviceException('$dev is not a Device object');
                    }
            }
            else
            {
                    $this->ip_version=4;
            }
        }

        public function constructDevice(Device $dev)
        {
                $this->id = $dev->getId();
                $this->name = $dev->getName();
                $this->description = $dev->getDescription();
                $this->type = $dev->getType();
                $this->ip = $dev->getIPv4Adress();
                $this->ip_version = $dev->getIPVersion();
        }

        public function setId($n)
        {
            $this->id=$n;
        }

        public function setName($n)
        {
            $this->name=$n;
        }

        public function setType($n)
        {
            $this->type=$n;
        }

        public function setDescription($n)
        {
            $this->description=$n;
        }

        public function setIPv4Adress($tip)
        {
            $tip = preg_replace('#\s+#','',$tip);
            if(preg_match('#[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}#',$tip))
            {
                    $this->ip = $tip;
                    return TRUE;
            }
            else
                    return FALSE;
        }

        public function setIPv4DecimalAdress($tip)
        {
            $this->ip = long2ip($tip);
        }

        public function setManufacturer($man)
        {
                $this->manufacturer=$man;
        }

        public function setOS($os)
        {
            $this->os=$os;
        }

        public function setOSVersion($os)
        {
            $this->os_version=$os;
        }

        public function getIPv4Adress()
        {
            return $this->ip;
        }

        public function getIPv4DecimalAdress()
        {
            return sprintf("%u\n", ip2long($this->ip));
        }

       public function getIPVersion()
       {
            return $this->ip_version;
       }

       public function getId()
       {
           if(isset($this->id) && !empty ($this->id))
                   return $this->id;
           else
                   return null;
       }

        public function getName(){
            return $this->name;
        }

       public function getDescription()
       {
                return $this->description;
       }

       public function getManufacturer(){
           return $this->manufacturer;
       }

       public function getOS(){
           return $this->os;
       }

       public function getOSVersion(){
           return $this->os_version;
       }

       public function getType(){
           return $this->type;
       }
}
