<?php
function waitVM($cluster,$vmid,$wanted_status,$timeout,$uptime=30)
{
    for($i=0;$i<$timeout;$i++)
    {
        $vm = $cluster->getVM($vmid,TRUE);
        $current_status = $vm->getState();

        //Ce qui est ci-dessous ne fonctione pas avec proxmox
/*
//        echo "$current_status</br>";

        if( $wanted_status == 'restart' && $current_status == 'running')
        {
//            echo $vm->getUpTime() . " < $uptime</br>";
            if( $vm->getUpTime() < $uptime )
            {
                return TRUE;
            }
        }
        */
        if( $current_status == $wanted_status)
        {
            return TRUE;
        }
        sleep(1);
    }
    return FALSE;
}

function getStatus($percent)
{
    if( $percent < 80 )
    {
        return 'OK';
    }
    elseif( $percent < 90 )
    {
        return 'WARNING';
    }
    else
    {
        return 'CRITICAL';
    }
}

function parseUptime($row,$nb=4)
{
	global $lang;
	$ut = $row;

	$days = round($ut/(3600*24),0,PHP_ROUND_HALF_DOWN);
	$ut %=(3600*24);

	$hours = round($ut/3600,0,PHP_ROUND_HALF_DOWN);
	$ut %=3600;

	$minutes =  round($ut/60,0,PHP_ROUND_HALF_DOWN);
	$ut %=60;
	$secondes = $ut;

    $calc = $days;
    $i = 1;
    if( $calc > 0 && $nb >= $i)
    {
	       $exp[] = $days;
	       $exp[] = $lang['VIRT_TIME_DAYS'];
           $i++;
    }
    $calc += $hours;
    if( $calc > 0 && $nb >= $i)
    {
	       $exp[] = $hours;
	       $exp[] = $lang['VIRT_TIME_HOURS'];
           $i++;
    }
    $calc += $minutes;
    if( $calc > 0 && $nb >= $i)
    {
	       $exp[] = $minutes;
	       $exp[] = $lang['VIRT_TIME_MINUTES'];
           $i++;
    }
    $calc += $secondes;
    if( $calc > 0 && $nb >= $i)
    {
    	$exp[] = $secondes;
    	$exp[] = $lang['VIRT_TIME_SECONDS'];
        $i++;
    }
	$ret = implode(' ',$exp);
	return $ret;
}

function bytesToHuman($usage,$total,$bits=FALSE)
{
    $free = $total-$usage;
    $ret['raw']['usage'] = $usage;
    $ret['raw']['free']  =
    $ret['raw']['total'] = $total;

    $ret['percent']['usage'] = round(($usage/$total)*100);
    $ret['percent']['free']  = round(($free/$total)*100);

    if( $bits ){
      $multiplicator = 1000;
    }
    else
    {
      $multiplicator = 1024;
    }

	  $ref = $total;
    if( $ref < pow(1000,1) * 10 )
    {
        $calcul = 1;
        $ret['human']['unit']   = 'B';
        $ret['human']['usage']  = round($usage/$calcul);
        $ret['human']['free']   = round($free/$calcul);
        $ret['human']['total']  = round($total/$calcul);
    }
    elseif( $ref < pow(1000,2) * 10 )
    {
        $calcul = pow($multiplicator,1);
        $ret['human']['unit']   = 'KB';
        $ret['human']['usage']  = round($usage/$calcul);
        $ret['human']['free']   = round($free/$calcul);
        $ret['human']['total']  = round($total/$calcul);
    }
    elseif( $ref < pow(1000,3) * 10 )
    {
        $calcul = pow($multiplicator,2);
        $ret['human']['unit']   = 'MB';
        $ret['human']['usage']  = round($usage/$calcul);
        $ret['human']['free']   = round($free/$calcul);
        $ret['human']['total']  = round($total/$calcul);
    }
    elseif( $ref < pow(1000,4) * 10 )
    {
        $calcul = pow($multiplicator,3);
        $ret['human']['unit']   = 'GB';
        $ret['human']['usage']  = round($usage/$calcul);
        $ret['human']['free']   = round($free/$calcul);
        $ret['human']['total']  = round($total/$calcul);
    }
    elseif( $ref < pow(1000,5) * 10 )
    {
        $calcul = pow($multiplicator,4);
        $ret['human']['unit']   = 'TB';
        $ret['human']['usage']  = round($usage/$calcul);
        $ret['human']['free']   = round($free/$calcul);
        $ret['human']['total']  = round($total/$calcul);
    }
    else
    {
        $calcul = pow($multiplicator,5);
        $ret['human']['unit']   = 'PB';
        $ret['human']['usage']  = round($usage/$calcul);
        $ret['human']['free']   = round($free/$calcul);
        $ret['human']['total']  = round($total/$calcul);
    }
    if( $bits )
    {
      $ret['human']['unit'] = ucfirst(strtolower($ret['human']['unit']));
    }
    return $ret;
}
