--BACKUP database : su postgres -c pg_dumpall > /root/pg_database_backup.sql
--RUN script :  su postgres -c 'psql -d esia -f ./install.sql'

CREATE TABLE virt_driver
(
        drv_id serial NOT NULL,
        drv_name character varying(20) NOT NULL,
        drv_type character varying (20),
        drv_path character varying (150),
        drv_admin_page character varying (150),
        CONSTRAINT virt_drv_id_primary_key PRIMARY KEY (drv_id),
        CONSTRAINT virt_drv_name_type_unique UNIQUE (drv_name)
);

ALTER TABLE virt_driver OWNER TO esia;

CREATE TABLE virt_hypervisor_in
(
        hyperv_device_id integer NOT NULL,
        hyperv_cluster_id integer NOT NULL,
        hyperv_hostname character varying (150),
        CONSTRAINT hyperv_device_id_ForeignKey_device_id FOREIGN KEY (hyperv_device_id) REFERENCES esia_device(device_id),
        CONSTRAINT hyperv_cluster_id_ForeignKey_cluster_id FOREIGN KEY (hyperv_cluster_id) REFERENCES esia_device(device_id),
        CONSTRAINT virt_hypervisor_primary_key PRIMARY KEY (hyperv_device_id)
);
ALTER TABLE virt_hypervisor_in OWNER TO esia;

--TODO : Déplacer dans web-interface ???
ALTER TABLE esia_web_plugin
    ALTER COLUMN web_plugin_apache_path TYPE character varying (30);

INSERT INTO esia_web_plugin(web_id, web_name, web_dir_lang, web_page_control, web_activate, web_plugin_apache_path)
VALUES (DEFAULT,'WEBP_HYPERVISOR','lang/','control_virtualization.php?nodeid=:id','true', '/plugin/virtualization/');

INSERT INTO esia_device_type (type_name,type_web_id) VALUES ('Hypervisor',(select web_id from esia_web_plugin where web_name='WEBP_HYPERVISOR'));
INSERT INTO esia_device_type (type_name,type_web_id) VALUES ('Virtual cluster',(select web_id from esia_web_plugin where web_name='WEBP_HYPERVISOR'));

INSERT INTO virt_driver(drv_name, drv_type,drv_path,drv_admin_page)
VALUES ('xenserver','api','xen-api.php','plugin/virtcluster/inc/admin/xen-xapi.php');
INSERT INTO virt_driver(drv_name, drv_type,drv_path,drv_admin_page)
VALUES ('proxmox','pam','proxmox-pam.php','plugin/virtcluster/inc/admin/pve-api.php');
INSERT INTO virt_driver(drv_name, drv_type,drv_path,drv_admin_page)
VALUES ('vmware','soapclient','vmware-soap.php','plugin/virtcluster/inc/admin/vmware-soap.php');

INSERT INTO esia_device_advance_config_type(device_config_type_name, device_config_type_controller,device_config_type_webplugin_id)
VALUES('VIRTUALIZATION','adv_virtualization.php',(SELECT web_id FROM esia_web_plugin WHERE web_name = 'WEBP_HYPERVISOR'));

--UPDATE esia_device_advance_config_type SET device_config_type_name = 'VIRTUALIZATION' WHERE device_config_type_name = 'WEBP_HYPERVISOR';

INSERT INTO esia_privileges(privilege_id, privilege_name, privilege_site, privilege_description)
VALUES (default,'virtualization_access' ,0,'Autorise l''accès au webplugin de virtualisation' );

INSERT INTO esia_privileges(privilege_id, privilege_name, privilege_site, privilege_description)
VALUES (default,'virtualization_vm_action' ,0,'Autorise des actions sur les VMs du webplugin virtualisation' );

INSERT INTO esia_privilege_grantedto( grant_group_id, grant_privilege_id, grant_acces) VALUES ((SELECT group_id FROM esia_groups WHERE group_name='root'), (SELECT privilege_id FROM esia_privileges WHERE privilege_name='virtualization_access'), 1);
INSERT INTO esia_privilege_grantedto( grant_group_id, grant_privilege_id, grant_acces) VALUES ((SELECT group_id FROM esia_groups WHERE group_name='root'), (SELECT privilege_id FROM esia_privileges WHERE privilege_name='virtualization_vm_action'), 1);
